package com.vendor.platform.ui;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.platform.core.PlatformCoreActivator;
import com.vendor.platform.core.internal.DeviceManager;
import com.vendor.platform.ui.Messages;
import com.vendor.platform.ui.PlatformUIActivator;
import org.eclipse.core.runtime.Plugin;
import org.eclipse.jface.preference.PreferencePage;
import org.eclipse.jface.resource.JFaceResources;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.vendor.preferences.Activator;
import org.vendor.preferences.Messages;
import org.vendor.preferences.ToolPreferences;
import org.vendor.tftp.prefences.Messages;
import org.vendor.tftp.prefences.TFTPPreferences;

public class ToolPreferencePage extends PreferencePage implements IWorkbenchPreferencePage {
  private static final String TOOL_PREF_DIALOG_ON_TOP = "dialog_on_top";
  
  private Button dialogOnTopBtn;
  
  private DeviceManager instance;
  
  private Button defaultChipBtn;
  
  private Text tftpTimeoutText;
  
  private Text KOText;
  
  public ToolPreferencePage() {
    noDefaultAndApplyButton();
  }
  
  public void init(IWorkbench workbench) {
    this.instance = (DeviceManager)DeviceManager.getInstance();
  }
  
  protected Control createContents(Composite parent) {
    Group globalSettings = new Group(parent, 0);
    globalSettings.setText(Messages.ToolPreferencePage_0);
    globalSettings.setLayout((Layout)new GridLayout(2, false));
    globalSettings.setLayoutData(new GridData(768));
    this.dialogOnTopBtn = new Button((Composite)globalSettings, 32);
    this.dialogOnTopBtn.setText(Messages.AbstractUIActivator_3);
    this.dialogOnTopBtn
      .setSelection(Activator.getDefault().getPreferenceStore()
        .getBoolean("dialog_on_top"));
    this.defaultChipBtn = new Button((Composite)globalSettings, 32);
    this.defaultChipBtn.setText(Messages.AbstractUIActivator_2);
    this.defaultChipBtn.setSelection(this.instance.needPopupDevice());
    Group netSettings = new Group(parent, 0);
    netSettings.setText(Messages.ToolPreferencePage_1);
    netSettings.setLayout((Layout)new GridLayout(2, false));
    netSettings.setLayoutData(new GridData(768));
    (new Label((Composite)netSettings, 0)).setText(Messages.Preferences_Timeout + " (s)");
    this.tftpTimeoutText = new Text((Composite)netSettings, 2048);
    this.tftpTimeoutText
      .setText("" + TFTPPreferences.getTimeout());
    this.tftpTimeoutText.setLayoutData(new GridData(768));
    this.tftpTimeoutText.addModifyListener((ModifyListener)new Object(this));
    Group KOSettings = new Group(parent, 0);
    KOSettings.setText(Messages.PreferencePage_InstallKOCommand);
    KOSettings.setLayout((Layout)new GridLayout(2, false));
    KOSettings.setLayoutData(new GridData(768));
    (new Label((Composite)KOSettings, 0)).setText(Messages.PreferencePage_InstallKOCommand);
    this.KOText = new Text((Composite)KOSettings, 2048);
    this.KOText.setText(ToolPreferences.getPreferenceKOCommand());
    this.KOText.setLayoutData(new GridData(768));
    return (Control)parent;
  }
  
  protected void validate() {
    String timeout = this.tftpTimeoutText.getText();
    String timeoutWarning = JFaceResources.format("IntegerFieldEditor.errorMessageRange", new Object[] { Integer.valueOf(1), Integer.valueOf(60) });
    try {
      int iTimeout = Integer.parseInt(timeout);
      if (iTimeout < 1 || iTimeout > 60) {
        setErrorMessage(timeoutWarning);
        setValid(false);
        updateApplyButton();
        return;
      } 
    } catch (NumberFormatException e) {
      setErrorMessage(timeoutWarning);
      setValid(false);
      updateApplyButton();
      return;
    } 
    setErrorMessage(null);
    setValid(true);
    updateApplyButton();
  }
  
  public boolean performOk() {
    try {
      Activator.getDefault().getPreferenceStore().setValue("dialog_on_top", this.dialogOnTopBtn.getSelection());
      this.instance.updateDevicePopup(this.defaultChipBtn.getSelection());
      TFTPPreferences.setTimeout(Integer.parseInt(this.tftpTimeoutText.getText()));
      ToolPreferences.setKOCommand(this.KOText.getText());
    } catch (NumberFormatException e) {
      PlatformCoreActivator.getLogger((Plugin)PlatformUIActivator.getDefault()).logError(e.getMessage(), e);
    } 
    return super.performOk();
  }
}
